//
//  IRotation.h
//  sdk_json_Objective-C
//
//  Created by Realbuber on 2024/5/7.
//

#ifndef IRotation_h
#define IRotation_h

#import <Foundation/Foundation.h>
#import <UniPRT/RotateEnum.h>

/**
 * @~english
 * @protocol IRotation
 *
 * @brief The rotation of an object.
 *
 * @ingroup Interface
 *
 * @~chinese
 * @protocol IRotation
 *
 * @brief 对象的旋转。
 *
 * @ingroup Interface
 *
 * @~Chinese-Traditional
 * @protocol IRotation
 *
 * @brief 對象的旋轉。
 *
 * @ingroup Interface
 */

@protocol IRotation <NSObject>

@property (nonatomic, assign) RotateEnum rotation;

@end


#endif /* IRotation_h */
