//
//  AMaxicodeBarcode.h
//  sdk_json_Objective-C
//
//  Created by Realbuber on 2024/5/8.
//

#ifndef AMaxicodeBarcode_h
#define AMaxicodeBarcode_h

#import <Foundation/Foundation.h>
#import <UniPRT/IMaxicodeBarcode.h>

/**
 * @~english
 * @class AMaxicodebarcode
 * @brief Base class for AMaxicodebarcode.
 * @ingroup Interface
 *
 *
 * @~chinese
 * @class AMaxicodebarcode
 * @brief AMaxicodebarcode 的基类。
 * @ingroup Interface
 *
 *
 * @~Chinese-Traditional
 * @class AMaxicodebarcode
 * @brief AMaxicodebarcode 的基類。
 * @ingroup Interface
 *
 */

@interface AMaxicodeBarcode : NSObject <IMaxicodeBarcode>

@property (nonatomic, strong) id<IMaxicodeData> data;
@property (nonatomic, strong) id<IRuler> ruler;
@property (nonatomic, strong) id<IPoint> start;

- (instancetype)init;
- (instancetype)initWithStart:(id<IPoint>)start data:(id<IMaxicodeData>)data NS_DESIGNATED_INITIALIZER;

@end

#endif /* AMaxicodeBarcode_h */
